Index: LMDZ4/branches/V3_test/libf/dyn3dpar/calfis_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/calfis_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/calfis_p.F	(revision 709)
@@ -23,5 +23,5 @@
      $                  pdq,
      $                  pw,
-#ifdef INCA_CH4
+#ifdef INCA
      $                  flxw,
 #endif
@@ -40,4 +40,5 @@
       Use Write_field_p
       USE Times
+      USE IOPHY
       IMPLICIT NONE
 c=======================================================================
@@ -148,25 +149,56 @@
 
       INTEGER i,j,l,ig0,ig,iq,iiq
-      REAL zpsrf(klon)
-      REAL zplev(klon,llm+1),zplay(klon,llm)
-      REAL zphi(klon,llm),zphis(klon)
-c
-      REAL zufi(klon,llm), zvfi(klon,llm)
-      REAL ztfi(klon,llm),zqfi(klon,llm,nqmx)
-c
-      REAL pcvgu(klon,llm), pcvgv(klon,llm)
-      REAL pcvgt(klon,llm), pcvgq(klon,llm,2)
-c
-      REAL pvervel(klon,llm)
-c
-      REAL zdufi(klon,llm),zdvfi(klon,llm)
-      REAL zdtfi(klon,llm),zdqfi(klon,llm,nqmx)
-      REAL zdpsrf(klon)
-c
+      REAL,ALLOCATABLE,SAVE :: zpsrf(:)
+      REAL,ALLOCATABLE,SAVE :: zplev(:,:),zplay(:,:)
+      REAL,ALLOCATABLE,SAVE :: zphi(:,:),zphis(:)
+c
+      REAL,ALLOCATABLE,SAVE :: zufi(:,:), zvfi(:,:)
+      REAL,ALLOCATABLE,SAVE :: ztfi(:,:),zqfi(:,:,:)
+c
+      REAL,ALLOCATABLE,SAVE :: pcvgu(:,:), pcvgv(:,:)
+      REAL,ALLOCATABLE,SAVE :: pcvgt(:,:), pcvgq(:,:,:)
+c
+      REAL,ALLOCATABLE,SAVE :: pvervel(:,:)
+c
+      REAL,ALLOCATABLE,SAVE :: zdufi(:,:),zdvfi(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdtfi(:,:),zdqfi(:,:,:)
+      REAL,ALLOCATABLE,SAVE :: zdpsrf(:)
+c
+      REAL,ALLOCATABLE,SAVE :: zplev_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zplay_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zphi_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zphis_omp(:)
+      REAL,ALLOCATABLE,SAVE :: presnivs_omp(:)
+      REAL,ALLOCATABLE,SAVE :: zufi_omp(:,:) 
+      REAL,ALLOCATABLE,SAVE :: zvfi_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: ztfi_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zqfi_omp(:,:,:)
+      REAL,ALLOCATABLE,SAVE :: pvervel_omp(:,:) 
+      REAL,ALLOCATABLE,SAVE :: zdufi_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdvfi_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdtfi_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdqfi_omp(:,:,:)
+      REAL,ALLOCATABLE,SAVE :: zdpsrf_omp(:)
+
+c$OMP THREADPRIVATE(zplev_omp,zplay_omp,zphi_omp,zphis_omp,
+c$OMP+                 presnivs_omp,zufi_omp,zvfi_omp,ztfi_omp,
+c$OMP+                 zqfi_omp,pvervel_omp,zdufi_omp,zdvfi_omp,
+c$OMP+                 zdtfi_omp,zdqfi_omp,zdpsrf_omp)       
+
+      LOGICAL,SAVE :: first_omp=.true.
+c$OMP THREADPRIVATE(first_omp)
+      
       REAL zsin(iim),zcos(iim),z1(iim)
       REAL zsinbis(iim),zcosbis(iim),z1bis(iim)
       REAL unskap, pksurcp
-
-#ifdef INCA_CH4
+c
+cIM diagnostique PVteta, Amip2
+      INTEGER ntetaSTD
+      PARAMETER(ntetaSTD=3)
+      REAL rtetaSTD(ntetaSTD)
+      DATA rtetaSTD/350., 380., 405./
+      REAL PVteta(klon,ntetaSTD)
+      
+#ifdef INCA
       REAL flxw(iip1,jjp1,llm)
       REAL flxwfi(klon,llm)
@@ -179,12 +211,14 @@
       DATA firstcal/.true./
       SAVE firstcal,debut
+c$OMP THREADPRIVATE(firstcal,debut)
       REAL rdayvrai
       
-      REAL,dimension(1:iim,1:llm) :: du_send,du_recv,dv_send,dv_recv
+      REAL,SAVE,dimension(1:iim,1:llm):: du_send,du_recv,dv_send,dv_recv
       INTEGER :: ierr
       INTEGER,dimension(MPI_STATUS_SIZE,4) :: Status
       INTEGER, dimension(4) :: Req
-      REAL zdufi2(klon+iim,llm),zdvfi2(klon+iim,llm)
-      integer :: k,kstart,kend     
+      REAL,ALLOCATABLE,SAVE:: zdufi2(:,:),zdvfi2(:,:)
+      integer :: k,kstart,kend
+      INTEGER :: offset  
 c
 c-----------------------------------------------------------------------
@@ -194,4 +228,8 @@
 c
 
+      klon=klon_mpi
+      
+      PVteta(:,:)=0.
+            
       IF (ngridmx.NE.2+(jjm-1)*iim) THEN
          PRINT*,'STOP dans calfis'
@@ -209,4 +247,19 @@
       IF ( firstcal )  THEN
           debut = .TRUE.
+c$OMP MASTER
+      ALLOCATE(zpsrf(klon))
+      ALLOCATE(zplev(klon,llm+1),zplay(klon,llm))
+      ALLOCATE(zphi(klon,llm),zphis(klon))
+      ALLOCATE(zufi(klon,llm), zvfi(klon,llm))
+      ALLOCATE(ztfi(klon,llm),zqfi(klon,llm,nqmx))
+      ALLOCATE(pcvgu(klon,llm), pcvgv(klon,llm))
+      ALLOCATE(pcvgt(klon,llm), pcvgq(klon,llm,2))
+      ALLOCATE(pvervel(klon,llm))
+      ALLOCATE(zdufi(klon,llm),zdvfi(klon,llm))
+      ALLOCATE(zdtfi(klon,llm),zdqfi(klon,llm,nqmx))
+      ALLOCATE(zdpsrf(klon))
+      ALLOCATE(zdufi2(klon+iim,llm),zdvfi2(klon+iim,llm))
+c$OMP END MASTER
+c$OMP BARRIER	  
       ELSE
           debut = .FALSE.
@@ -222,6 +275,9 @@
 c   ----------------------------------
 
+c$OMP MASTER
       call start_timer(timer_physic)
-             
+c$OMP END MASTER
+
+c$OMP MASTER             
       do ig0=1,klon
         i=Liste_i(ig0)
@@ -229,5 +285,5 @@
         zpsrf(ig0)=pps(i,j)
       enddo
-
+c$OMP END MASTER
 
 
@@ -243,4 +299,6 @@
        unskap   = 1./ kappa
 c
+      print *,omp_rank,'klon--->',klon
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l = 1, llmp1
         do ig0=1,klon
@@ -250,4 +308,5 @@
         enddo
       ENDDO
+c$OMP END DO NOWAIT
 c
 c
@@ -255,5 +314,5 @@
 c   43. temperature naturelle (en K) et pressions milieux couches .
 c   ---------------------------------------------------------------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
 
@@ -268,4 +327,5 @@
 
       ENDDO
+c$OMP END DO NOWAIT
 
 c   43.bis traceurs
@@ -275,4 +335,5 @@
       DO iq=1,nq
          iiq=niadv(iq)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
            do ig0=1,klon
@@ -282,4 +343,5 @@
            enddo
          ENDDO
+c$OMP END DO NOWAIT	 
       ENDDO
 
@@ -287,4 +349,5 @@
 
       DO iq=1,2
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
          DO l=1,llm
            do ig0=1,klon
@@ -294,4 +357,5 @@
            enddo
          ENDDO
+c$OMP END DO NOWAIT	 
       ENDDO
 
@@ -302,6 +366,11 @@
 
       CALL gr_dyn_fi_p(llm,iip1,jjp1,klon,pphi,zphi)
+
+c$OMP MASTER
       CALL gr_dyn_fi_p(1,iip1,jjp1,klon,pphis,zphis)
-
+c$OMP END MASTER
+c$OMP BARRIER
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
 	 DO ig=1,klon
@@ -309,8 +378,8 @@
 	 ENDDO
       ENDDO
-      
+c$OMP END DO NOWAIT      
 c   ....  Calcul de la vitesse  verticale  ( en Pa*m*s  ou Kg/s )  ....
 c
-       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO l=1,llm
         do ig0=1,klon
@@ -322,5 +391,5 @@
 	if (pole_sud) pvervel(klon,l)=pw(1,jjp1,l)*g/apols
       ENDDO
-
+c$OMP END DO NOWAIT
 
 c
@@ -334,4 +403,5 @@
       if (pole_sud) kend=klon-1
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l=1,llm
         do ig0=kstart,kend
@@ -351,8 +421,8 @@
         enddo
       ENDDO
-
+c$OMP END DO NOWAIT
 c   46.champ v:
 c   -----------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
         DO ig0=kstart,kend
@@ -366,5 +436,5 @@
          ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
 
 c   47. champs de vents aux pole nord   
@@ -374,5 +444,5 @@
 
       if (pole_nord) then
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
         DO l=1,llm
 
@@ -397,5 +467,5 @@
   
         ENDDO
-      
+c$OMP END DO NOWAIT      
       endif
 
@@ -407,5 +477,5 @@
 
       if (pole_sud) then
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
         DO l=1,llm
   
@@ -430,9 +500,17 @@
 
         ENDDO
-      
+c$OMP END DO NOWAIT       
       endif
 
 
-#ifdef INCA_CH4
+      IF (monocpu) THEN
+c
+cIM calcul PV a teta=350, 380, 405K
+        CALL PVtheta(ngridmx,llm,pucov,pvcov,pteta,
+     $           ztfi,zplay,zplev,
+     $           ntetaSTD,rtetaSTD,PVteta)
+c
+      ENDIF
+#ifdef INCA
       CALL gr_dyn_fi_p(llm,iip1,jjp1,klon,flxw,flxwfi)
 #endif
@@ -443,5 +521,135 @@
 c   ---------------------
 
-
+cc$OMP  PARALLEL DEFAULT(NONE) 
+cc$OMP+ PRIVATE(i,l,offset,iq)
+cc$OMP+ SHARED(klon_omp_nb,nq,klon_omp_begin,
+cc$OMP+        debut,lafin,rdayvrai,heure,dtphys,zplev,zplay,
+cc$OMP+        zphi,zphis,presnivs,clesphy0,zufi,zvfi,ztfi,
+cc$OMP+        zqfi,pvervel,zdufi,zdvfi,zdtfi,zdqfi,zdpsrf)
+
+c PRIVATE(zplev_omp,zplay_omp,zphi_omp,zphis_omp,
+c c$OMP+                 presnivs_omp,zufi_omp,zvfi_omp,ztfi_omp,
+c c$OMP+                 zqfi_omp,pvervel_omp,zdufi_omp,zdvfi_omp,
+c c$OMP+                 zdtfi_omp,zdqfi_omp,zdpsrf_omp)
+
+c$OMP BARRIER
+      if (first_omp) then
+        klon=klon_omp_nb(omp_rank)
+
+        allocate(zplev_omp(klon,llm+1))
+        allocate(zplay_omp(klon,llm))
+        allocate(zphi_omp(klon,llm))
+        allocate(zphis_omp(klon))
+        allocate(presnivs_omp(llm))
+        allocate(zufi_omp(klon,llm))
+        allocate(zvfi_omp(klon,llm))
+        allocate(ztfi_omp(klon,llm))
+        allocate(zqfi_omp(klon,llm,nq))
+        allocate(pvervel_omp(klon,llm))
+        allocate(zdufi_omp(klon,llm))
+        allocate(zdvfi_omp(klon,llm))
+        allocate(zdtfi_omp(klon,llm))
+        allocate(zdqfi_omp(klon,llm,nq))
+        allocate(zdpsrf_omp(klon))
+	first_omp=.false.
+      endif
+       
+	   
+      klon=klon_omp_nb(omp_rank)
+      offset=klon_omp_begin(omp_rank)-1
+      
+      do l=1,llm+1
+        do i=1,klon
+          zplev_omp(i,l)=zplev(offset+i,l)
+	enddo 
+      enddo
+	  
+       do l=1,llm
+        do i=1,klon  
+	  zplay_omp(i,l)=zplay(offset+i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zphi_omp(i,l)=zphi(offset+i,l)
+	enddo 
+      enddo
+	
+
+      do i=1,klon
+	zphis_omp(i)=zphis(offset+i)
+      enddo 
+     
+	
+      do l=1,llm
+        presnivs_omp(l)=presnivs(l)
+      enddo 
+	
+      do l=1,llm
+        do i=1,klon
+	  zufi_omp(i,l)=zufi(offset+i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zvfi_omp(i,l)=zvfi(offset+i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  ztfi_omp(i,l)=ztfi(offset+i,l)
+	enddo 
+      enddo
+	
+      do iq=1,nq
+        do l=1,llm
+          do i=1,klon
+            zqfi_omp(i,l,iq)=zqfi(offset+i,l,iq)
+	  enddo
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  pvervel_omp(i,l)=pvervel(offset+i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zdufi_omp(i,l)=zdufi(offset+i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zdvfi_omp(i,l)=zdvfi(offset+i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+          zdtfi_omp(i,l)=zdtfi(offset+i,l)
+	enddo 
+      enddo
+	
+      do iq=1,nq
+        do l=1,llm
+          do i=1,klon
+	    zdqfi_omp(i,l,iq)=zdqfi(offset+i,l,iq)
+	  enddo 
+        enddo
+      enddo
+      	
+      do i=1,klon
+	zdpsrf_omp(i)=zdpsrf(offset+i)
+      enddo 
+      
+c$OMP BARRIER
+cym      call WriteField_phy_p('zdtfi_omp',zdtfi_omp(:,:),llm)
+      
       CALL physiq (klon,
      .             llm,
@@ -452,49 +660,165 @@
      .             heure,
      .             dtphys,
-     .             zplev,
-     .             zplay,
-     .             zphi,
-     .             zphis,
-     .             presnivs,
+     .             zplev_omp,
+     .             zplay_omp,
+     .             zphi_omp,
+     .             zphis_omp,
+     .             presnivs_omp,
      .             clesphy0,
-     .             zufi,
-     .             zvfi,
-     .             ztfi,
-     .             zqfi,
-     .             pvervel,
-#ifdef INCA_CH4
+     .             zufi_omp,
+     .             zvfi_omp,
+     .             ztfi_omp,
+     .             zqfi_omp,
+     .             pvervel_omp,
+#ifdef INCA
      .             flxwfi,
 #endif
-     .             zdufi,
-     .             zdvfi,
-     .             zdtfi,
-     .             zdqfi,
-     .             zdpsrf)
-
+     .             zdufi_omp,
+     .             zdvfi_omp,
+     .             zdtfi_omp,
+     .             zdqfi_omp,
+     .             zdpsrf_omp,
+cIM diagnostique PVteta, Amip2          
+     .             pducov,
+     .             PVteta)
+
+cym      call WriteField_phy_p('zdtfi_omp',zdtfi_omp(:,:),llm)
+
+c$OMP BARRIER
+
+      do l=1,llm+1
+        do i=1,klon
+          zplev(offset+i,l)=zplev_omp(i,l)
+	enddo 
+      enddo
+	  
+       do l=1,llm
+        do i=1,klon  
+	  zplay(offset+i,l)=zplay_omp(i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zphi(offset+i,l)=zphi_omp(i,l)
+	enddo 
+      enddo
+	
+
+      do i=1,klon
+	zphis(offset+i)=zphis_omp(i)
+      enddo 
+     
+	
+      do l=1,llm
+        presnivs(l)=presnivs_omp(l)
+      enddo 
+	
+      do l=1,llm
+        do i=1,klon
+	  zufi(offset+i,l)=zufi_omp(i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zvfi(offset+i,l)=zvfi_omp(i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  ztfi(offset+i,l)=ztfi_omp(i,l)
+	enddo 
+      enddo
+	
+      do iq=1,nq
+        do l=1,llm
+          do i=1,klon
+            zqfi(offset+i,l,iq)=zqfi_omp(i,l,iq)
+	  enddo
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  pvervel(offset+i,l)=pvervel_omp(i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zdufi(offset+i,l)=zdufi_omp(i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+	  zdvfi(offset+i,l)=zdvfi_omp(i,l)
+	enddo 
+      enddo
+	
+      do l=1,llm
+        do i=1,klon
+          zdtfi(offset+i,l)=zdtfi_omp(i,l)
+	enddo 
+      enddo
+	
+      do iq=1,nq
+        do l=1,llm
+          do i=1,klon
+	    zdqfi(offset+i,l,iq)=zdqfi_omp(i,l,iq)
+	  enddo 
+        enddo
+      enddo
+      	
+      do i=1,klon
+	zdpsrf(offset+i)=zdpsrf_omp(i)
+      enddo 
+      
+
+cc$OMP END PARALLEL
+      klon=klon_mpi
 500   CONTINUE
-
+c$OMP BARRIER
+
+c$OMP MASTER
+cym      call WriteField_phy('zdtfi',zdtfi(:,:),llm)
       call stop_timer(timer_physic)
+c$OMP END MASTER
       
       if (MPI_rank>0) then
-      
-        du_send(1:iim,1:llm)=zdufi(1:iim,1:llm)
-        dv_send(1:iim,1:llm)=zdvfi(1:iim,1:llm)
-        
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
+       DO l=1,llm      
+        du_send(1:iim,l)=zdufi(1:iim,l)
+        dv_send(1:iim,l)=zdvfi(1:iim,l)
+       ENDDO
+c$OMP END DO NOWAIT       
+
+c$OMP BARRIER
+c$OMP MASTER
         call MPI_ISSEND(du_send,iim*llm,MPI_REAL8,MPI_Rank-1,401,
-     &                   MPI_COMM_WORLD,Req(1),ierr)
+     &                   COMM_LMDZ,Req(1),ierr)
         call MPI_ISSEND(dv_send,iim*llm,MPI_REAL8,MPI_Rank-1,402,
-     &                  MPI_COMM_WORLD,Req(2),ierr)
+     &                  COMM_LMDZ,Req(2),ierr)
+c$OMP END MASTER
+c$OMP BARRIER
      
       endif
    
       if (MPI_rank<MPI_Size-1) then
-      
+c$OMP BARRIER
+c$OMP MASTER      
         call MPI_IRECV(du_recv,iim*llm,MPI_REAL8,MPI_Rank+1,401,
-     &                 MPI_COMM_WORLD,Req(3),ierr)
+     &                 COMM_LMDZ,Req(3),ierr)
         call MPI_IRECV(dv_recv,iim*llm,MPI_REAL8,MPI_Rank+1,402,
-     &                 MPI_COMM_WORLD,Req(4),ierr)
-     
+     &                 COMM_LMDZ,Req(4),ierr)
+c$OMP END MASTER
+c$OMP BARRIER     
       endif
-   
+
+c$OMP BARRIER
+c$OMP MASTER    
       if (MPI_rank>0 .and. MPI_rank< MPI_Size-1) then
         call MPI_WAITALL(4,Req(1),Status,ierr)
@@ -504,25 +828,37 @@
         call MPI_WAITALL(2,Req(3),Status,ierr)
       endif
-      
-      zdufi2(1:klon,:)=zdufi(1:klon,:)
-      zdufi2(klon+1:klon+iim,:)=du_recv(1:iim,:)
-          
-      zdvfi2(1:klon,:)=zdvfi(1:klon,:)
-      zdvfi2(klon+1:klon+iim,:)=dv_recv(1:iim,:)
-
-       pdhfi(:,jjphy_begin,:)=0
-       pdqfi(:,jjphy_begin,:,:)=0
-       pdufi(:,jjphy_begin,:)=0
-       pdvfi(:,jjphy_begin,:)=0
-       pdpsfi(:,jjphy_begin)=0
-
+c$OMP END MASTER
+c$OMP BARRIER     
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,llm
+            
+        zdufi2(1:klon,l)=zdufi(1:klon,l)
+        zdufi2(klon+1:klon+iim,l)=du_recv(1:iim,l)
+            
+        zdvfi2(1:klon,l)=zdvfi(1:klon,l)
+        zdvfi2(klon+1:klon+iim,l)=dv_recv(1:iim,l) 
+  
+         pdhfi(:,jjphy_begin,l)=0
+         pdqfi(:,jjphy_begin,l,:)=0
+         pdufi(:,jjphy_begin,l)=0
+         pdvfi(:,jjphy_begin,l)=0
+         
+         if (.not. pole_sud) then
+           pdhfi(:,jjphy_end,l)=0
+           pdqfi(:,jjphy_end,l,:)=0
+           pdufi(:,jjphy_end,l)=0
+           pdvfi(:,jjphy_end,l)=0
+         endif
+      
+       ENDDO 
+c$OMP END DO NOWAIT
+
+c$OMP MASTER
+       pdpsfi(:,jjphy_begin)=0    
        if (.not. pole_sud) then
-         pdhfi(:,jjphy_end,:)=0
-         pdqfi(:,jjphy_end,:,:)=0
-         pdufi(:,jjphy_end,:)=0
-         pdvfi(:,jjphy_end,:)=0
 	 pdpsfi(:,jjphy_end)=0
        endif
-
+c$OMP END MASTER
 c-----------------------------------------------------------------------
 c   transformation des tendances physiques en tendances dynamiques:
@@ -531,6 +867,7 @@
 c  tendance sur la pression :
 c  -----------------------------------
-
+c$OMP MASTER
       CALL gr_fi_dyn_p(1,klon,iip1,jjp1,zdpsrf,pdpsfi)
+c$OMP END MASTER
 c
 c   62. enthalpie potentielle
@@ -543,7 +880,8 @@
       if (pole_sud)  kend=klon-1
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
 
-!cdir NODEP
+!!cdir NODEP
         do ig0=kstart,kend
           i=Liste_i(ig0)
@@ -565,4 +903,5 @@
         endif
       ENDDO
+c$OMP END DO NOWAIT
       
 c   62. humidite specifique
@@ -570,6 +909,7 @@
 
       DO iq=1,nqmx
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
-!cdir NODEP 
+!!cdir NODEP 
            do ig0=kstart,kend
              i=Liste_i(ig0)
@@ -592,4 +932,5 @@
            
          ENDDO
+c$OMP END DO NOWAIT
       ENDDO
 
@@ -597,12 +938,19 @@
 c   ------------
 C     initialisation des tendances
-      pdqfi=0.
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,llm
+        pdqfi(:,:,l,:)=0.
+      ENDDO
+c$OMP END DO NOWAIT	 
+
 C
 
       DO iq=1,nq
          iiq=niadv(iq)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
 
-!cdir NODEP           
+!!cdir NODEP           
 	     DO ig0=kstart,kend
               i=Liste_i(ig0)
@@ -625,11 +973,12 @@
 	    
          ENDDO
+c$OMP END DO NOWAIT	 
       ENDDO
       
 c   65. champ u:
 c   ------------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
-!cdir NODEP
+!!cdir NODEP
          do ig0=kstart,kend
            i=Liste_i(ig0)
@@ -643,5 +992,5 @@
               pdufi(iim,j,l)=0.5*(  zdufi2(ig0,l)
      $                            + zdufi2(ig0+iim-1,l))*cu(iim,j)
-              pdufi(iip1,j,l)=0.5*(zdufi2(ig0,l)+zdufi2(ig0+1,l))*cu(i,j)
+             pdufi(iip1,j,l)=0.5*(zdufi2(ig0,l)+zdufi2(ig0+1,l))*cu(i,j)
            endif
          
@@ -661,5 +1010,5 @@
          
       ENDDO
-
+c$OMP END DO NOWAIT
 
 c   67. champ v:
@@ -672,6 +1021,7 @@
       if (pole_sud)  kend=klon-1-iim
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l=1,llm
-!cdir NODEP
+!!cdir NODEP
         do ig0=kstart,kend
            i=Liste_i(ig0)
@@ -684,4 +1034,5 @@
          
       ENDDO
+c$OMP END DO NOWAIT
 
 
@@ -691,5 +1042,6 @@
 
       if (pole_nord) then
-        
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
         DO l=1,llm
 
@@ -705,10 +1057,12 @@
 
         ENDDO
+c$OMP END DO NOWAIT
 
       endif    
       
       if (pole_sud) then
-      
-        DO l=1,llm
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+         DO l=1,llm
   
            DO i=1,iim
@@ -723,4 +1077,5 @@
 
         ENDDO
+c$OMP END DO NOWAIT
      
       endif
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/conf_dat2d.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/conf_dat2d.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/conf_dat2d.F	(revision 709)
@@ -215,4 +215,7 @@
        ENDDO
 
+      deallocate(xtemp)
+      deallocate(ytemp)
+
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/conf_gcm.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/conf_gcm.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/conf_gcm.F	(revision 709)
@@ -372,4 +372,16 @@
        iflag_con = 2
        CALL getin('iflag_con',iflag_con)
+!
+!Config  Key  = ip_ebil_dyn
+!Config  Desc = PRINT level for energy conserv. diag.
+!Config  Def  = 0
+!Config  Help = PRINT level for energy conservation diag. ;
+!               les options suivantes existent :
+!Config         0 pas de print
+!Config         1 pas de print
+!Config         2 print,
+       ip_ebil_dyn = 0
+       CALL getin('ip_ebil_dyn',ip_ebil_dyn)
+!
 
       DO i = 1, longcles
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/control.h
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/control.h	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/control.h	(revision 709)
@@ -8,8 +8,9 @@
      .              iperiod,iapp_tracvl,iconser,iecri,idissip,iphysiq ,
      .              periodav,ecritphy,iecrimoy,dayref,anneeref,
-     .              raz_date,offline
+     .              raz_date,offline,ip_ebil_dyn
 
       INTEGER   nday,day_step,iperiod,iapp_tracvl,iconser,iecri,
-     .          idissip,iphysiq,iecrimoy,dayref,anneeref, raz_date
+     .          idissip,iphysiq,iecrimoy,dayref,anneeref, raz_date,
+     .          ip_ebil_dyn 
       REAL periodav, ecritphy
       logical offline
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/convflu_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/convflu_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/convflu_p.F	(revision 709)
@@ -33,5 +33,5 @@
 c
      
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)          
       DO 5 l = 1,nbniv
 c
@@ -80,5 +80,5 @@
       
    5  CONTINUE
-   
+c$OMP END DO NOWAIT   
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/convmas_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/convmas_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/convmas_p.F	(revision 709)
@@ -35,14 +35,11 @@
 #include "logic.h"
 
-      REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm ),convm(  ip1jmp1,llm )
+      REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm )
+      REAL, target :: convm(  ip1jmp1,llm )
       INTEGER   l,ij
 
-      EXTERNAL   filtreg_p
-      EXTERNAL   convflu_p
+      INTEGER ijb,ije,jjb,jje
+ 
       
-      INTEGER ijb,ije,jjb,jje
-     
-      
-
 c-----------------------------------------------------------------------
 c    ....  calcul de - (d(pbaru)/dx + d(pbarv)/dy ) ......
@@ -64,4 +61,5 @@
        ije=ij_end+iip1
        if (pole_sud) ije=ij_end
+            
       DO      l      = llmm1, 1, -1
         DO    ij     = ijb, ije
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/covcont_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/covcont_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/covcont_p.F	(revision 709)
@@ -42,5 +42,6 @@
         ije_v=ij_end-iip1
       endif
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
       DO 10 l = 1,klevel
 
@@ -54,4 +55,5 @@
 
   10  CONTINUE
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/dissip_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/dissip_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/dissip_p.F	(revision 709)
@@ -49,6 +49,4 @@
 
       REAL  SSUM
-      EXTERNAL  gradiv ,nXgrarot,divgrad,initial0
-      EXTERNAL  gradiv2,nXgraro2,divgrad2,SSUM
       integer :: ijb,ije
 c-----------------------------------------------------------------------
@@ -56,4 +54,5 @@
 c   ----------------
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
       DO l=1,llm
          te1dt(l) = tetaudiv(l) * dtdiss
@@ -61,4 +60,5 @@
          te3dt(l) = tetah(l)    * dtdiss
       ENDDO
+c$OMP END DO NOWAIT
 c      CALL initial0( ijp1llm, du )
 c      CALL initial0( ijmllm , dv )
@@ -67,11 +67,19 @@
       ijb=ij_begin
       ije=ij_end
-      
-      du(ijb:ije,:)=0
-      dh(ijb:ije,:)=0
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
+      DO l=1,llm
+        du(ijb:ije,l)=0
+        dh(ijb:ije,l)=0
+      ENDDO
+c$OMP END DO NOWAIT
       
       if (pole_sud) ije=ij_end-iip1
-      
-      dv(ijb:ije,:)=0
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
+      DO l=1,llm
+        dv(ijb:ije,l)=0
+      ENDDO
+c$OMP END DO NOWAIT
      
 c-----------------------------------------------------------------------
@@ -99,4 +107,5 @@
       if (pole_sud) ije=ij_end-iip1
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
       DO l=1,llm
          if (pole_nord) then
@@ -123,5 +132,5 @@
 
        ENDDO
-
+c$OMP END DO NOWAIT
 c   calcul de la partie   n X grad ( rot ):
 c   ---------------------------------------
@@ -142,5 +151,6 @@
       ije=ij_end
       if (pole_sud) ije=ij_end-iip1
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO l=1,llm
          
@@ -162,4 +172,5 @@
       
       ENDDO
+c$OMP END DO NOWAIT
 
 c   calcul de la partie   div ( grad ):
@@ -172,5 +183,6 @@
       ijb=ij_begin
       ije=ij_end
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
        DO l = 1, llm
           DO ij = ijb, ije
@@ -178,5 +190,5 @@
           ENDDO
        ENDDO
-
+c$OMP END DO NOWAIT
          CALL divgrad2_p( llm,teta, deltapres  ,niterh, gdx )
       ELSE
@@ -190,4 +202,5 @@
       ije=ij_end
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l = 1,llm
          DO ij = ijb,ije
@@ -195,4 +208,5 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
       RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/diverg_gam_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/diverg_gam_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/diverg_gam_p.F	(revision 709)
@@ -48,5 +48,6 @@
       if (pole_nord) ijb=ij_begin+iip1
       if(pole_sud)  ije=ij_end-iip1
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO 10 l = 1,klevel
 c
@@ -90,4 +91,5 @@
        endif
   10  CONTINUE
+c$OMP END DO NOWAIT
 c
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/diverg_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/diverg_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/diverg_p.F	(revision 709)
@@ -46,4 +46,5 @@
       if(pole_sud)  ije=ij_end-iip1
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO 10 l = 1,klevel
 c
@@ -88,4 +89,5 @@
 
   10  CONTINUE
+c$OMP END DO NOWAIT
 c
 
@@ -93,4 +95,5 @@
       
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
         DO l = 1, klevel
            DO ij = ijb,ije
@@ -98,4 +101,5 @@
           ENDDO
         ENDDO
+c$OMP END DO NOWAIT
 c
        RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/divergf_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/divergf_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/divergf_p.F	(revision 709)
@@ -45,5 +45,6 @@
       if (pole_nord) ijb=ij_begin+iip1
       if(pole_sud)  ije=ij_end-iip1
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO 10 l = 1,klevel
 c
@@ -53,4 +54,5 @@
      *   cuvsurcv(ij-iim) * y(ij-iim,l) - cuvsurcv(ij+1) * y(ij+1,l) 
         ENDDO
+
 c
 c     ....  correction pour  div( 1,j,l)  ......
@@ -92,4 +94,6 @@
         
   10    CONTINUE
+c$OMP END DO NOWAIT
+
 c
         jjb=jj_begin
@@ -100,4 +104,5 @@
       
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
         DO l = 1, klevel
            DO ij = ijb,ije
@@ -105,4 +110,5 @@
           ENDDO
         ENDDO
+c$OMP END DO NOWAIT
 c
        RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/divgrad2_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/divgrad2_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/divgrad2_p.F	(revision 709)
@@ -1,3 +1,3 @@
-      SUBROUTINE divgrad2_p ( klevel, h, deltapres, lh, divgra )
+      SUBROUTINE divgrad2_p ( klevel, h, deltapres, lh, divgra_out )
 c
 c     P. Le Van
@@ -23,5 +23,7 @@
       INTEGER klevel
       REAL h( ip1jmp1,klevel ), deltapres( ip1jmp1,klevel )
-      REAL divgra( ip1jmp1,klevel)
+      REAL divgra_out( ip1jmp1,klevel)
+      REAL,SAVE :: divgra( ip1jmp1,llm)
+
 c
 c    .......    variables  locales    ..........
@@ -31,6 +33,4 @@
 c    ...................................................................
 
-      EXTERNAL  filtreg
-      EXTERNAL  SCOPY,  laplacien_gam
       INTEGER ijb,ije
 c
@@ -41,12 +41,20 @@
       ijb=ij_begin
       ije=ij_end
-      divgra(ijb:ije,1:klevel)=h(ijb:ije,1:klevel)
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, klevel
+        divgra(ijb:ije,l)=h(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
 c
+c$OMP BARRIER
+c$OMP MASTER
       call suspend_timer(timer_dissip)
       call exchange_Hallo(divgra,ip1jmp1,llm,1,1)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
       CALL laplacien_p( klevel, divgra, divgra )
-     
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)     
       DO l = 1, klevel
        DO ij = ijb, ije
@@ -54,5 +62,8 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
+
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)     
       DO l = 1, klevel
         DO ij = ijb, ije
@@ -60,11 +71,16 @@
         ENDDO
       ENDDO
+c$OMP END DO NOWAIT
    
 c    ........    Iteration de l'operateur  laplacien_gam    ........
 c
       DO  iter = 1, lh - 2
+c$OMP BARRIER
+c$OMP MASTER
        call suspend_timer(timer_dissip)
        call exchange_Hallo(divgra,ip1jmp1,llm,1,1)
        call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
        CALL laplacien_gam_p ( klevel,cuvscvgam2,cvuscugam2,unsair_gam2,
      *                     unsapolnga2, unsapolsga2,  divgra, divgra )
@@ -72,5 +88,6 @@
 c
 c    ...............................................................
- 
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)     
       DO l = 1, klevel
         DO ij = ijb, ije
@@ -78,15 +95,23 @@
         ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 c
+c$OMP BARRIER
+c$OMP MASTER
       call suspend_timer(timer_dissip)
       call exchange_Hallo(divgra,ip1jmp1,llm,1,1)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
+
       CALL laplacien_p ( klevel, divgra, divgra )
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l  = 1,klevel
       DO ij = ijb,ije
-      divgra(ij,l) =  nudivgrs * divgra(ij,l) / deltapres(ij,l)
+      divgra_out(ij,l) =  nudivgrs * divgra(ij,l) / deltapres(ij,l)
       ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
       RETURN
